
extends _base.pug

block title
  span Auto Property Example

block ssvg
  h5 Update the inputs to modify the state:
  .input-group.w-100.mb-1
    .input-group-prepend
      span.input-group-text number
    .input-group-append.flex-grow-1
      span.border.w-100.px-1
        input.form-control#input(type="range" value="0" max='100')
  .input-group.w-100.mb-1
    .input-group-prepend
      span.input-group-text string
    input.form-control#textinput(type="text")
  .input-group.mb-1
    .input-group-prepend
      span.input-group-text boolean
    .input-group-append
      .form-control
        input#checkbox(type="checkbox")
  
  s-svg#ssvg
    svg#svg(height="20em" width="100%" xmlns="http://www.w3.org/2000/svg")
      state.
        transition(duration="3s" timing-function='ease-in-out')
        // add min/max to set an initial range, it will be preserved on internal type change
        property(name="value" type="auto")
          // display direct value
          direct(query-selector='#text1' onupdate='`current value: ${$value}`')
            transition(duration="0s")
          // re-compute and display normalized value
          relation(query-selector='#text2' from='0' to='1' onupdate='parseFloat(Number($value).toFixed(2))')
            transition(duration="0s")
          // the relation should work, no matter the property internal type
          relation(query-selector='#rect1' attribute-name='width' from='0' to='100%')
          relation(query-selector='#rect1' attribute-name='fill' values='chartreuse;gainsboro;honeydew')

      rect#rect1(width="10%" height="20%" fill='black' stroke='black')
      text#text1(x='50%' y='50%' fill='black' text-anchor='middle')
      text(x='50%' y='50%' dy='1em' fill='black' text-anchor='middle')
        | normalized value: #[tspan#text2]

  script(src=basePath + "/dist/ssvg-engine.js")
  script.
    ssvg.plugin();
    $(document).ready(() => {
      const ssvg = $('#ssvg');
      const input = $('#input');
      input.val(0);

      input.on('input', function() {
        ssvg.get(0).setState({ value: parseFloat(this.value) });
      });
      
      $('#textinput').on('input', function() {
        ssvg.get(0).setState({ value: this.value });
      });

      $('#checkbox').on('input', function() {
        ssvg.get(0).setState({ value: this.checked });
      });
    });
